var SONOS_PORT = 1400; 
var URL_CONNECT_TIMEOUT = 100; // in miliseconds!!!
var STOP_COMMAND_INDEX = 1;
var DEF_REPEAT_TIME = 30; // seconds
var TEST_PLAY_TIME = 10; // time in seconds to restore Test Activity
var NR_ITEMS_FETCHED_FROM_FAVORITES = 100; // max number of items fetched from SONOS favorites
var NR_ITEMS_FETCHED_FROM_PLAYLIST = 100;  // max number of items fetched from SONOS playlists

var SONOS_ACTION_NOW_PLAYING = 0;
var SONOS_ACTION_PLAYLIST    = 1;
var SONOS_ACTION_FAVORITES   = 2;
var SONOS_ACTION_LIBRARY     = 3;
var SONOS_ACTION_TTS         = 4;
var SONOS_ACTION_COMMAND     = 5;

var INVALID_PLAYER_ID = -1;

var COMMAND_NONE = 0;
var COMMAND_STOP = 1;
var COMMAND_PLAY = 2;
var COMMAND_PAUSE = 3;
var COMMAND_MUTE = 4;
var COMMAND_UNMUTE = 5;
var COMMAND_VOLUME_UP = 6;
var COMMAND_VOLUME_DOWN = 7;

var TMP_SONOS_QUEUE_NAME = "dSS-tmp";

var predefinedUnduEvents = new Array(76, 65, 74, 83, 84, 85);                                                                                                    
         
var predefinedActivities = new Array(
          {scene:72, 
           group:0, 
           zone:0, 
           type:'bus-zone-scene', 
           actionType:SONOS_ACTION_COMMAND, 
           command:COMMAND_STOP}, // leaving home
           
          {name:'fire', 
           state:'active', 
           type:'state-change', 
           actionType:SONOS_ACTION_LIBRARY, 
           groupRooms:1, 
           volume:50, 
           repeat:3, 
           restart:0,  
           file:new Array({'guid':'32c731e1-0171-a846-b291-de55bceeedfa', 'lang':'EN'},
                          {'guid':'ed520c04-803b-19f9-d6b9-05819134b60d', 'lang':'DE'},
                          {'guid':'32aa1a01-4833-e4c7-c7e0-ea55ef972f2a', 'lang':'FR'},
                          {'guid':'c6a40b67-5a31-8652-4f10-73c042029a15', 'lang':'NL'}
                         ),                                
           groupID:'3e36f94e-8c20-4f3c-8418-51709e32147a', 
           subGroupID:'47af3b4f-3ba5-42aa-b79e-cc770605bb2f', 
           title:'Fire Alarm'
          }, //fire

          {scene:65, 
           group:0, 
           zone:0, 
           type:'bus-zone-scene', 
           actionType:SONOS_ACTION_LIBRARY, 
           groupRooms:1, 
           volume:50, 
           repeat:3, 
           restart:0,  
           file:[{'guid':'0d2c425a-857a-fa88-7511-19355415538a', 'lang':'EN'}], 
           groupID:'782e04ca-ed1b-4c1a-830d-f2a7b33e9531', 
           title:'Panic'
          }, //panic
          
          {name:'hail', 
           state:'active', 
           type:'state-change', 
           actionType:SONOS_ACTION_LIBRARY, 
           groupRooms:1, 
           volume:25, 
           repeat:0, 
           restart:1, 
           file:new Array({'guid':'ffc09a32-45fb-2492-4998-342c8e8c045e', 'lang':'EN'},
                          {'guid':'ab5fb906-59f3-f3da-8190-bcf680c184ce', 'lang':'DE'},
                          {'guid':'c5d42cb3-5e09-cc95-cbb7-03f214dd6cc6', 'lang':'FR'}
                         ),   
           groupID:'3e36f94e-8c20-4f3c-8418-51709e32147a', 
           subGroupID:'8b65e868-1404-4762-b416-f398526cc08d', 
           title:'Hail Warning'}, //hail
           
          {scene:73, 
           group:0, 
           zone:0, 
           type:'bus-zone-scene', 
           actionType:SONOS_ACTION_LIBRARY, 
           groupRooms:1, 
           volume:40, 
           repeat:0, 
           restart:1,  
           file:[{'guid':'8b785dbf-04e3-ee66-2dda-9593e2a20a48', 'lang':'EN'}], 
           groupID:'5f5f01b2-63e8-4131-8e20-ec86e1920d20', 
           title:'Doorbell'} //dorbell
         );  


var predefinedRoomEvents = new Array();
predefinedRoomEvents[COMMAND_PAUSE] = new Array({name:'Preset 0',  id:0, group:4, trigger:'sonos_execute_pause'},
                                                {name:'Preset 10', id:32, group:4, trigger:'sonos_execute_pause'},
                                                {name:'Preset 20', id:34, group:4, trigger:'sonos_execute_pause'},
                                                {name:'Preset 30', id:36, group:4, trigger:'sonos_execute_pause'},
                                                {name:'Preset 40', id:38, group:4, trigger:'sonos_execute_pause'},
                                                {name:'Standby',   id:67, group:0, trigger:'sonos_execute_pause'},
                                                {name:'Deep-off',  id:68, group:0, trigger:'sonos_execute_pause'});

predefinedRoomEvents[COMMAND_PLAY] = new Array({name:'Preset 1', id:5, group:4, trigger:'sonos_execute'},
                                               {name:'Preset 11', id:33, group:4, trigger:'sonos_execute'},
                                               {name:'Preset 21', id:35, group:4, trigger:'sonos_execute'},
                                               {name:'Preset 31', id:37, group:4, trigger:'sonos_execute'},
                                               {name:'Preset 41', id:39, group:4, trigger:'sonos_execute'});
predefinedRoomEvents[COMMAND_VOLUME_UP] = new Array({name:'Volume Up', id:12, group:4, trigger:'sonos_execute_volume'});                                             
predefinedRoomEvents[COMMAND_VOLUME_DOWN] = new Array({name:'Volume Down', id:11, group:4, trigger:'sonos_execute_volume'});                                             
                                               
/* moved from triggers to callBusScene                                               
predefinedRoomEvents[COMMAND_VOLUME_UP] = new Array({name:'Volume Up', id:12, group:4});                                             
predefinedRoomEvents[COMMAND_VOLUME_DOWN] = new Array({name:'Volume Down', id:11, group:4});                                             
*/
                                     
function cleanXMLText(sXML) {
  return sXML.replace(/&(lt|gt|quot|amp;apos);/g, function(m, t) {
                            switch (t) {
                              case 'lt':
                                return '<';
                              case 'gt':
                                return '>';
                              case 'quot':   
                                return '\"';
                              case 'amp;apos':
                                return "\'";
                              default:
                               return "";
                            }
                         }); 
} 

function secondToInt(sSeconds) {
  var a = sSeconds.split(':');
  return ((+a[0]) * 3600) + ((+a[1]) * 60) + (+a[2]); 
}

function storeSubParameter(root, path, value) {
  Property.setProperty(root +'/' + path, value);
  Property.setFlag(root + '/' + path, 'ARCHIVE', true);
  lInfo.logln("STORING " + root + "/" + path + " -> " + value);
}

function storeSubParameterFull(path, value) {
  Property.setProperty(path, value);
  Property.setFlag(path, 'ARCHIVE', true);
  lInfo.logln("STORING " +path + " -> " + value);
}

 
function getXMLFields(szXMLRespond, szXMLFieldName, szXMLCloseName) {
    szXMLCloseName = typeof szXMLCloseName !== 'undefined' ? szXMLCloseName : '';
    var sEnd = '</' + szXMLFieldName + ">"
    if (szXMLCloseName != '')
     sEnd = szXMLCloseName;
 
    var xml_text = cleanXMLText(szXMLRespond);
   // lInfo.logln("Value: " + xml_text);    
    
    var returnValues = new Array();
    do
    {        
        var start_pos = xml_text.indexOf("<" + szXMLFieldName+" ");
        var end_pos = xml_text.indexOf(sEnd) + sEnd.length;
       // lInfo.logln("Pos: " + start_pos + ","+end_pos);

        if (start_pos == -1 || end_pos == -1)
            break;

        var searched_value = xml_text.substring(start_pos, end_pos);
      //  lInfo.logln("Value: " + searched_value);

        if (searched_value.length > 0)
          returnValues.push({data:searched_value});
          
        xml_text = xml_text.substring(end_pos);
    }
    while (xml_text != '')
    
    return returnValues;
}

function addSlavePlayersToGroup(sSlaves, arraySonosGroups, sMasterGroupDevice, curl_options) {
  if (sSlaves != "") {
    var arraySlaves = sSlaves.split(';');  
    for (var xIndex=0;xIndex<arraySlaves.length;xIndex++) {
      var sSlaveID = arraySlaves[xIndex].trim();
      if (sSlaveID != '') { 
        var sSlaveIP = getZoneGroupMemberIP(arraySonosGroups, sSlaveID);
        if (sSlaveIP != "") { 
          lInfo.logln("Adding slave to tmpGroup "+sSlaveIP);
          upnpSetContentSrc(sSlaveIP, "x-rincon:"+sMasterGroupDevice, curl_options);
        }
      }
    }
  }
}

function getZoneGroupMemberIP(aGroups, sDeviceID) {
  if (aGroups != null) {
    for (var iIndex=0;iIndex<aGroups.length;iIndex++) {
      var aMembers = aGroups[iIndex].members; 
      if (aMembers != null) {
        for (var xIndex=0;xIndex<aMembers.length;xIndex++) {
          var tmpDevice = aMembers[xIndex].match(/UUID=\"(.*?)\"/); 
          if (tmpDevice != null) {
            if (tmpDevice[1] == sDeviceID) {
lInfo.logln("FOUND DEVICE IN XML "+sDeviceID);   
              var tmpIP = aMembers[xIndex].match(/Location=\"(.*?)\"/);
              if (tmpIP != null) {
                var matches = tmpIP[1].match(/:\/\/(.[^:]+)/); // get ip from full url
                if (matches != null) {
                  sDeviceIP = matches[1];
                  return sDeviceIP;
                }
              }
            }
          } 
        }
      }
    }
  }
  return "";
}  

function replaceAll(find, replace, str) {
  return str.replace(new RegExp(find, 'g'), replace);
}

var Utf8 = {
    // public method for url encoding
    encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    }
};

 
