var VOLUME_STEP = 5;
var SONOS_PORT = 1400; 

var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "sonos-controller.log";
lInfo = new Logger(LOGFILE_NAME);

function upnpParseXMLRespond(szXMLRespond, szXMLFieldName, szContainsText) {
    //lInfo.logln(szXMLRespond);
    var searched_value = '';
    var found = 0;
    var xml_text = '';
    var start_pos = 0;
    
    xml_text = szXMLRespond;
    
    do
    {        
        start_pos = xml_text.indexOf('<' + szXMLFieldName);
        
        if (start_pos == -1)
        {
            break;
        }
        
        start_pos += szXMLFieldName.length + 1;
        start_pos += 1 /* skip '>' */;
        
        var end_pos = xml_text.indexOf('</' + szXMLFieldName);
        
        if (end_pos == -1)
        {
            break;
        };
            
        searched_value = xml_text.substring(start_pos, end_pos);
        
        if (szContainsText != "")
        {
            if (searched_value.indexOf(szContainsText) == -1)
            {
                start_pos = end_pos + szXMLFieldName.length + 1;
                xml_text = xml_text.substring(start_pos, xml_text.length);
                
                lInfo.logln("Filter not match, continue search: : " + xml_text);                
            }
            else
            {
                found = 1;
            }
        }
        else
        {
            found = 1;
        }
    }
    while ((szContainsText != "") && (found == 0) && (xml_text != ""))
    
    lInfo.logln("XML parser found: " + searched_value);

    return searched_value;
}

function upnpSetVolume(szIpAddressRenderer, nVolume, oCurlOptions) {
  try {
    var http_headers = [];
    http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
    http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:RenderingControl:1#SetVolume"';

    var h = new HTTP(oCurlOptions, http_headers);
    h.reset();
                           
    var url = 'http://' + szIpAddressRenderer + ':' + SONOS_PORT + '/MediaRenderer/RenderingControl/Control';

    var action = '<?xml version="1.0" encoding="utf-8"?>' 
              + '<s:Envelope s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">'
              + '<s:Body>'
                 + '<u:SetVolume xmlns:u="urn:schemas-upnp-org:service:RenderingControl:1">'
                 + '<InstanceID>0</InstanceID>'
                 + '<Channel>Master</Channel>'
                 + '<DesiredVolume>'+nVolume+'</DesiredVolume>'
                 + '</u:SetVolume>'
              + '</s:Body>'
              + '</s:Envelope>'
 
    var result = h.post(url, '', action);
    
    if (result != null)
      lInfo.logln(result.body);
  }
  catch (e) {
      lInfo.logln("Error executing upnpSetVolume command " + e);
  }
}

function upnpGetVolume(szIpAddressRenderer, oCurlOptions) {
  try {
    var http_headers = [];
    http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
    http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:RenderingControl:1#GetVolume"';//

    var h = new HTTP(oCurlOptions, http_headers);
    
    h.reset();
    var url = 'http://'+ szIpAddressRenderer + ':' + SONOS_PORT + '/MediaRenderer/RenderingControl/Control';
   
    var action = '<?xml version="1.0" encoding="utf-8"?>' 
              + '<s:Envelope s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">'
              + '<s:Body>'
                 + '<u:GetVolume xmlns:u="urn:schemas-upnp-org:service:RenderingControl:1">'
                 + '<InstanceID>0</InstanceID>'
                 + '<Channel>Master</Channel>'
                 + '</u:GetVolume>'
              + '</s:Body>'
              + '</s:Envelope>'; 
    result = h.post(url, '', action);
    
    if (result.body != null) {
      return upnpParseXMLRespond(result.body, 'CurrentVolume', '')
    }
  } catch (e) {
    lInfo.logln("Error executing upnpGetVolume command " + e);
  }
  return null;
}

lInfo.logln("VOLUME ONLY");
lInfo.logln("sceneID: ", raisedEvent.parameter.sceneID);
lInfo.logln("groupID: ", raisedEvent.parameter.groupID);


var nSceneID =  parseInt("" + raisedEvent.parameter.sceneID, 10);

var sPlayerIP = "";
var sGroupedSlavesIP = "";
var execPreset = Property.getNode(raisedEvent.parameter.path);
if (execPreset != null){
  var nZoneID =  parseInt("" + execPreset.getChild('roomID').getValue(), 10);
  var baseNode = Property.getNode('sonos-players');
  if (baseNode != null) {
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
      var oChildNode = oArrayNode[iIndex];
      if (!JSON.parse(oChildNode.getChild('disabled').getValue())) {
        if (nZoneID == parseInt("" + oChildNode.getChild('roomID').getValue(),10)) {
          sPlayerIP = oChildNode.getChild('ipAddress').getValue();
          sGroupedSlavesIP = oChildNode.getChild('playersListIPSlaves').getValue();
          break;
        }
      }
    }
  }
}
lInfo.logln("VOLUME ONLY playerIP: ", sPlayerIP);

if (sPlayerIP.length > 0) {
  var curl_options = new Object({'debug' : 1, 'connectTimeout' : 200}); 
  var currentVolume = upnpGetVolume(sPlayerIP, curl_options);
  if (currentVolume != null) {
    var nVolume = parseInt("" + currentVolume,10);
    lInfo.logln("PLAYER VOLUME : ", nVolume);

    var bChangeVolume = true;
    if (nSceneID == 11) {
      if (nVolume < 1)
         bChangeVolume = false;
       nVolume = nVolume - VOLUME_STEP;
       if (nVolume < 0)
         nVolume = 0;
    }
    else if (nSceneID == 12) {
      if (nVolume > 99)
        bChangeVolume = false;
      nVolume = nVolume + VOLUME_STEP;
      if (nVolume > 100)
        nVolume = 100;
    } 
  
    if (bChangeVolume) {
      lInfo.logln("NEW VOLUME SET : ", nVolume);
      upnpSetVolume(sPlayerIP, nVolume, curl_options);

      var aSlaves = null;
      if (sGroupedSlavesIP.length > 0) {
        aSlaves = sGroupedSlavesIP.split(","); 
        // send volume comand to all slaves players if grouped 
        if (aSlaves != null && aSlaves.length > 0) {
          for (var iIndex=0;iIndex<aSlaves.length;iIndex++) {
            var sSlaveIP = aSlaves[iIndex].trim();
            var currentVolume = upnpGetVolume(sSlaveIP, curl_options);
            if (currentVolume != null) {
              var nVolume = parseInt("" + currentVolume,10);

              var bChangeVolume = true;
              if (nSceneID == 11) {
                if (nVolume < 1)
                   bChangeVolume = false;
                 nVolume = nVolume - VOLUME_STEP;
                 if (nVolume < 0)
                   nVolume = 0;
              }
              else if (nSceneID == 12) {
                if (nVolume > 99)
                  bChangeVolume = false;
                nVolume = nVolume + VOLUME_STEP;
                if (nVolume > 100)
                  nVolume = 100;
              } 
              
              if(bChangeVolume) {
                lInfo.logln("Set slave volume for "+sSlaveIP);
                upnpSetVolume(sSlaveIP, nVolume, curl_options);
              }
            }
          }
        }
      }
    }
  }
}
